from glob import glob

import numpy as np

from aux_functions import load_pickle, save_pickle

EXP_NO = 2

MODEL_SIZE = 1

CRITERIA = ""

data_type = {"cifar": "CIFAR", "mnist": "MNIST"}

experiment_criterias = {
    "Early": "/Early_Stopping",
    "Efficiency": "/Efficiency_Stopping",
    "100": "/100_epoch",
    "Accuracy": "/Accuracy_Bound",
    "Energy": "/Energy_Bound",
}

model_type = {"bayes": "bayes_exp_*.pkl", "freq": "freq_exp_data_*.pkl"}

EXPERIMENT_PATH = f"./EXPERIMENT_{EXP_NO}_DATA"

models_exp = {
    "cifar": {
        "bayes": {
            1: None,
            2: None,
            3: None,
            4: None,
            5: None,
            6: None,
            7: None,
        },
        "freq": {
            1: None,
            2: None,
            3: None,
            4: None,
            5: None,
            6: None,
            7: None,
        },
    },
    "mnist": {
        "bayes": {
            1: None,
            2: None,
            3: None,
            4: None,
            5: None,
            6: None,
            7: None,
        },
        "freq": {
            1: None,
            2: None,
            3: None,
            4: None,
            5: None,
            6: None,
            7: None,
        },
    },
}

path = (
    f"{EXPERIMENT_PATH}"
    f"{experiment_criterias['Efficiency']}"
    f"/{data_type['cifar']}"
    f"/{model_type['bayes']}"
)

path = glob(path)
for t in zip(range(1, 8), path):
    models_exp["cifar"]["bayes"][t[0]] = np.concatenate(load_pickle(t[1]), axis=0)

path = (
    f"{EXPERIMENT_PATH}"
    f"{experiment_criterias['Efficiency']}"
    f"/{data_type['mnist']}"
    f"/{model_type['bayes']}"
)

path = glob(path)
for t in zip(range(1, 8), path):
    models_exp["mnist"]["bayes"][t[0]] = np.concatenate(load_pickle(t[1]), axis=0)

path = (
    f"{EXPERIMENT_PATH}"
    f"{experiment_criterias['Efficiency']}"
    f"/{data_type['cifar']}"
    f"/{model_type['freq']}"
)

path = glob(path)
for t in zip(range(1, 8), path):
    models_exp["cifar"]["freq"][t[0]] = np.concatenate(load_pickle(t[1]), axis=0)

path = (
    f"{EXPERIMENT_PATH}"
    f"{experiment_criterias['Efficiency']}"
    f"/{data_type['mnist']}"
    f"/{model_type['freq']}"
)

path = glob(path)
for t in zip(range(1, 8), path):
    models_exp["mnist"]["freq"][t[0]] = np.concatenate(load_pickle(t[1]), axis=0)

# print(models_exp)
file_name = f"Experiment_{EXP_NO}_accuracy_data.pkl"
save_pickle(file_name, models_exp)
