from glob import glob

# can be 1,2 or 3
exp_no = 2

# can be 1 to 7
model_size = 1

crit = "Early"
experiment_criterias = {
    "Early": "/Early_Stopping",
    "Efficiency": "/Efficiency_Stopping",
    "100": "/100_epoch",
    "Accuracy": "/Accuracy_Bound",
    "Energy": "/Energy_Bound",
}

bcnn_path = {
    "prefix_path_mnist": "/checkpoints/MNIST/bayesian",
    "mid_path_mnist": "/model_lenet_lrt_softplus_",
    "prefix_path_cifar": "/checkpoints/CIFAR10/bayesian",
    "mid_path_cifar": "/model_lenet_lrt_softplus_",
    "end_path": "_epoch_",
    "noise_path": "_noise_",
    "suffix_path": ".pt",
}

lenet_path = {
    "prefix_path_mnist": "/checkpoints/MNIST/frequentist",
    "mid_path_mnist": "/model_lenet_",
    "prefix_path_cifar": "/checkpoints/CIFAR10/frequentist",
    "mid_path_cifar": "/model_lenet_",
    "end_path": "_epoch_",
    "noise_path": "_noise_",
    "suffix_path": ".pt",
}


# print(len(glob(experiment_2_path)))


def get_experiment_epochs(
    experiment_number=2, size=7, model_type="bcnn", data_type="cifar", stopping_criteria="Efficiency"
):
    models_epochs = {
        1: None,
        2: None,
        3: None,
        4: None,
        5: None,
        6: None,
        7: None,
    }
    EXPERIMENT_PATH = f"./EXPERIMENT_{experiment_number}_DATA"
    if (model_type == "bcnn") and (data_type == "cifar"):
        for s in range(size):
            experiment_path = (
                f"{EXPERIMENT_PATH}{experiment_criterias[stopping_criteria]}"
                f"{bcnn_path['prefix_path_cifar']}{bcnn_path['mid_path_cifar']}"
                f"{s+1}*.pt"
            )
            models_epochs[s + 1] = len(glob(experiment_path))
        return models_epochs
    if (model_type == "bcnn") and (data_type == "mnist"):
        for s in range(size):
            experiment_path = (
                f"{EXPERIMENT_PATH}{experiment_criterias[stopping_criteria]}"
                f"{bcnn_path['prefix_path_mnist']}{bcnn_path['mid_path_mnist']}"
                f"{s+1}*.pt"
            )
            models_epochs[s + 1] = len(glob(experiment_path))
        return models_epochs
    if (model_type == "lenet") and (data_type == "cifar"):
        for s in range(size):
            experiment_path = (
                f"{EXPERIMENT_PATH}{experiment_criterias[stopping_criteria]}"
                f"{lenet_path['prefix_path_cifar']}{lenet_path['mid_path_cifar']}"
                f"{s+1}*.pt"
            )
            models_epochs[s + 1] = len(glob(experiment_path))
        return models_epochs
    if (model_type == "lenet") and (data_type == "mnist"):
        for s in range(size):
            experiment_path = (
                f"{EXPERIMENT_PATH}{experiment_criterias[stopping_criteria]}"
                f"{lenet_path['prefix_path_mnist']}{lenet_path['mid_path_mnist']}"
                f"{s+1}*.pt"
            )
            models_epochs[s + 1] = len(glob(experiment_path))
        return models_epochs


# ./EXPERIMENT_2_DATA/Efficiency_Stopping/checkpoints/MNIST/frequentist/size_/model_lenet_7*.pt
# print(get_experiment_epochs(experiment_number=2, size=7, model_type="bcnn", data_type="mnist"))
